-- =============================================
-- Author:		FID.Ridwan
-- Create date: 2019-04-30
-- Description:	
-- =============================================
CREATE PROCEDURE [dbo].[SP_CED030100B_InsertTemp] @EO_Flag INT = 0
AS
BEGIN
	BEGIN TRY
		DECLARE @Username VARCHAR(30) = 'SYSTEM'
		DECLARE @T AS TABLE (PID BIGINT)
		DECLARE @pid AS BIGINT = 0
		DECLARE @log AS VARCHAR(MAX)
		DECLARE @MODULE_ID AS VARCHAR(1) = '3'
		DECLARE @FUNCTION_ID AS VARCHAR(5) = 'AG030100'
		DECLARE @R_SEQ_NO INT
		DECLARE @ORDER_RELEASE_FROM VARCHAR(MAX)
		DECLARE @ORDER_RELEASE_TO VARCHAR(MAX)
		--DECLARE @ORDER_RELEASE_EO_FROM INT
		--DECLARE @ORDER_RELEASE_EO_TO INT
		DECLARE @DOCK_CD VARCHAR(MAX);
		DECLARE @COMPANY_CD VARCHAR(MAX);
		DECLARE @RCV_PLANT_CD VARCHAR(MAX);
		DECLARE @ROUTE_PLANT VARCHAR(MAX);
		DECLARE @TB_T_LOG_D AS TABLE (
			PROCESS_ID BIGINT
			,SEQUENCE_NUMBER INT
			,MESSAGE_ID VARCHAR(12)
			,MESSAGE_TYPE VARCHAR(3)
			,[MESSAGE] VARCHAR(MAX)
			,LOCATION VARCHAR(MAX)
			,CREATED_BY VARCHAR(20)
			,CREATED_DATE DATETIME
			)
		DECLARE @ERRFLAG VARCHAR(MAX) = 'N';

		SET @log = 'Insert into Temp Table for sending data to TVEST is started' --'Starting [Create Kanban 2]';

		INSERT @T
		EXEC dbo.sp_PutLog @log
			,@Username
			,'Start log'
			,@pid OUTPUT
			,'MCEDSTD006I'
			,'INF'
			,@MODULE_ID
			,@FUNCTION_ID;

		SET @log = 'Executing get configuration setting process';

		INSERT INTO @TB_T_LOG_D
		SELECT @pid
			,NULL
			,'MCEDSTD021I'
			,'INF'
			,@log
			,'Get configuration setting'
			,@Username
			,GETDATE()

		SELECT @ORDER_RELEASE_FROM = TSYS.SYSTEM_VALUE
		FROM dbo.TB_M_SYSTEM TSYS
		WHERE TSYS.FUNCTION_ID = 'CED030100B'
			AND TSYS.SYSTEM_CD = 'ORDER_RELEASE_DATE_FROM'

		SELECT @ORDER_RELEASE_TO = TSYS.SYSTEM_VALUE
		FROM dbo.TB_M_SYSTEM TSYS
		WHERE TSYS.FUNCTION_ID = 'CED030100B'
			AND TSYS.SYSTEM_CD = 'ORDER_RELEASE_DATE_TO'

		SELECT @DOCK_CD = TSYS.SYSTEM_VALUE
		FROM dbo.TB_M_SYSTEM TSYS
		WHERE TSYS.FUNCTION_ID = 'CED030100B'
			AND TSYS.SYSTEM_CD = 'DOCK_CD'

		SELECT @COMPANY_CD = TSYS.SYSTEM_VALUE
		FROM dbo.TB_M_SYSTEM TSYS
		WHERE TSYS.FUNCTION_ID = 'CED030100B'
			AND TSYS.SYSTEM_CD = 'COMPANY_CD'

		SELECT @RCV_PLANT_CD = TSYS.SYSTEM_VALUE
		FROM dbo.TB_M_SYSTEM TSYS
		WHERE TSYS.FUNCTION_ID = 'CED030100B'
			AND TSYS.SYSTEM_CD = 'RCV_PLANT_CD'

		--FID) Dina 18-Jun-2019 : Filter exclude Route Plane
		SELECT @ROUTE_PLANT = TSYS.SYSTEM_VALUE
		FROM TB_M_SYSTEM TSYS
		WHERE TSYS.FUNCTION_ID = 'CED030100B'
			AND TSYS.SYSTEM_CD = 'ROUTE_PLANE'

		--IF @EO_Flag = 1
		--BEGIN
		--	SELECT @ORDER_RELEASE_EO_FROM = TSYS.SYSTEM_VALUE
		--	FROM dbo.TB_M_SYSTEM TSYS
		--	WHERE TSYS.FUNCTION_ID = 'CED030100B'
		--		AND TSYS.SYSTEM_CD = 'ORDER_RELEASE_DATE_EO_FROM'
		--	SELECT @ORDER_RELEASE_EO_TO = TSYS.SYSTEM_VALUE
		--	FROM dbo.TB_M_SYSTEM TSYS
		--	WHERE TSYS.FUNCTION_ID = 'CED030100B'
		--		AND TSYS.SYSTEM_CD = 'ORDER_RELEASE_DATE_EO_TO'
		--END
		--= Check Parameter =--
		IF ISNULL(@ORDER_RELEASE_FROM, '') = ''
		BEGIN
			SET @ERRFLAG = 'Y';

			SELECT 'NE|CED030100B;ORDER_RELEASE_DATE_FROM' AS isResult
		END

		IF ISNULL(@ORDER_RELEASE_TO, '') = ''
		BEGIN
			SET @ERRFLAG = 'Y';

			SELECT 'NE|CED030100B;ORDER_RELEASE_DATE_TO' AS isResult
		END

		IF ISNULL(@DOCK_CD, '') = ''
		BEGIN
			SET @ERRFLAG = 'Y';

			SELECT 'NE|CED030100B;DOCK_CD' AS isResult
		END

		IF ISNULL(@COMPANY_CD, '') = ''
		BEGIN
			SET @ERRFLAG = 'Y';

			SELECT 'NE|CED030100B;COMPANY_CD' AS isResult
		END

		IF ISNULL(@RCV_PLANT_CD, '') = ''
		BEGIN
			SET @ERRFLAG = 'Y';

			SELECT 'NE|CED030100B;RCV_PLANT_CD' AS isResult
		END

		IF ISNULL(@ROUTE_PLANT, '') = ''
		BEGIN
			SET @ERRFLAG = 'Y';

			SELECT 'NE|CED030100B;ROUTE_PLANE' AS isResult
		END

		IF ISNULL(@ORDER_RELEASE_FROM, '') <> ''
			AND ISNUMERIC(@ORDER_RELEASE_FROM) = 0
		BEGIN
			SET @ERRFLAG = 'Y';

			SELECT 'BE|MCEDSTD063E;ORDER_RELEASE_FROM;NUMERIC' AS isResult
		END

		IF ISNULL(@ORDER_RELEASE_TO, '') <> ''
			AND ISNUMERIC(@ORDER_RELEASE_TO) = 0
		BEGIN
			SET @ERRFLAG = 'Y';

			SELECT 'BE|MCEDSTD063E;ORDER_RELEASE_TO;NUMERIC' AS isResult
		END

		IF (
				ISNUMERIC(@ORDER_RELEASE_FROM) = 1
				AND ISNUMERIC(@ORDER_RELEASE_TO) = 1
				)
			AND (CONVERT(DATE, GETDATE() + CAST(@ORDER_RELEASE_TO AS INT)) < CONVERT(DATE, GETDATE() - CAST(@ORDER_RELEASE_FROM AS INT)))
		BEGIN
			SET @ERRFLAG = 'Y';

			SELECT 'BE|MCEDSTD000E;Date to must be greater than Date from;' AS isResult
		END

		--IF (ISNUMERIC(@ORDER_RELEASE_FROM) = 1 
		--	AND ISNUMERIC(@ORDER_RELEASE_TO) = 1 
		--	AND CAST(@ORDER_RELEASE_FROM AS INT) >= 0 
		--	AND (CAST(@ORDER_RELEASE_TO AS INT) < 0 
		--	AND ABS(CAST(@ORDER_RELEASE_TO AS INT)) <> CAST(@ORDER_RELEASE_FROM AS INT)))
		--BEGIN
		--	SET @ERRFLAG = 'Y';
		--	SELECT 'BE|MCEDSTD000E;Date to must be greater than Date from;' AS isResult
		--END
		--IF (ISNUMERIC(@ORDER_RELEASE_FROM) = 1 
		--	AND ISNUMERIC(@ORDER_RELEASE_TO) = 1 
		--	AND CAST(@ORDER_RELEASE_FROM AS INT) < 0 
		--	AND CAST(@ORDER_RELEASE_TO AS INT) < 0)
		--BEGIN
		--	SET @ERRFLAG = 'Y';
		--	SELECT 'BE|MCEDSTD000E;Date to must be greater than Date from;' AS isResult
		--END 
		IF @ERRFLAG <> 'Y'
		BEGIN
			DELETE
			FROM TB_T_CED_SUPPLIER

			DELETE
			FROM TB_T_CED_DOCK

			DELETE
			FROM TB_T_CED_PART_INFO

			DELETE
			FROM TB_T_CED_PART

			DELETE
			FROM TB_T_CED_PART_UNIQUE

			DELETE
			FROM TB_T_CED_PART_TYPE

			DELETE
			FROM TB_T_CED_LOGISTIC_PARTNER

			DELETE
			FROM TB_T_CED_DELIVERY_STATION_MAPPING

			DELETE
			FROM TB_T_CED_PHYSICAL_DOCK_MAPPING

			DELETE
			FROM TB_T_CED_DAILY_ORDER_MANIFEST

			DELETE
			FROM TB_T_CED_DAILY_ORDER_PART

			DELETE
			FROM TB_T_CED_DELIVERY_CTL_MANIFEST

			DELETE
			FROM TB_T_CED_DELIVERY_CTL_H

			DELETE
			FROM TB_T_CED_DELIVERY_CTL_D

			DELETE
			FROM TB_T_CED_DCL_TLMS_DRIVER_DATA

			DELETE
			FROM TB_T_CED_DCL_TLMS_ORDER_ASSIGNMENT

			--= Insert into supplier =--
			INSERT INTO [TB_T_CED_SUPPLIER] (
				PROCESS_ID
				,SUPPLIER_CD
				,SUPPLIER_PLANT_CD
				,SUPPLIER_ABBREVIATION
				,SUPPLIER_NAME
				,SYNC_FLAG
				,PROCESSED_BY
				,PROCESSED_DT
				)
			SELECT DISTINCT @pid
				,SUPPLIER_CODE
				,SUPPLIER_PLANT_CD
				,SUPPLIER_ABBREVIATION
				,SUPPLIER_NAME
				,'1'
				,@UserName
				,GETDATE()
			FROM [dbo].[TB_M_SUPPLIER]

			--= Insert into Dock =--
			INSERT INTO TB_T_CED_DOCK (
				PROCESS_ID
				,DOCK_CD
				,PLANT_CD
				,DOCK_NM
				,PRODUCTION_DT
				,COMPANY_CD
				,SYNC_FLAG
				,PROCESSED_BY
				,PROCESSED_DT
				)
			SELECT DISTINCT @pid
				,DOCK_CD
				,PLANT_CD
				,DOCK_NM
				,PRODUCTION_DT
				,COMPANY_CD
				,'1'
				,@UserName
				,GETDATE()
			FROM [dbo].[TB_M_DOCK]
			WHERE COMPANY_CD IN (
					SELECT items
					FROM dbo.FN_SPLIT(@COMPANY_CD, ';')
					)
				--FID) Dina 12-Aug-2019 : Additional filter by selected dock cd
				AND DOCK_CD IN (
					SELECT items
					FROM dbo.FN_SPLIT(@DOCK_CD, ';')
					)

			--= Insert into Part Info =--
			INSERT INTO TB_T_CED_PART_INFO (
				PROCESS_ID
				,PART_NO
				,SUPPLIER_CD
				,SUPPLIER_PLANT
				,DOCK_CD
				,KANBAN_NO
				,PART_NAME
				,PCK_TYPE
				,KANBAN_QTY
				,SAFETY_PCS
				,LINE_LEAD_TIME
				,START_DT
				,END_DT
				,CREATED_DT
				,CHANGED_DT
				,SYNC_FLAG
				,PROCESSED_BY
				,PROCESSED_DT
				)
			SELECT DISTINCT @pid
				,PART_NO
				,SUPPLIER_CD
				,SUPPLIER_PLANT
				,DOCK_CD
				,KANBAN_NO
				,PART_NAME
				,PCK_TYPE
				,KANBAN_QTY
				,SAFETY_PCS
				,LINE_LEAD_TIME
				,START_DT
				,END_DT
				,CREATED_DT
				,CHANGED_DT
				,'1'
				,@UserName
				,GETDATE()
			FROM [dbo].[TB_M_PART_INFO]
			WHERE DOCK_CD IN (
					SELECT items
					FROM dbo.FN_SPLIT(@DOCK_CD, ';')
					)

			--= Insert into Part =--
			INSERT INTO TB_T_CED_PART (
				PROCESS_ID
				,PART_NO
				,PART_NAME
				,SYNC_FLAG
				,PROCESSED_BY
				,PROCESSED_DT
				)
			SELECT DISTINCT @pid
				,PART_NO
				,MAX(PART_NAME) PART_NAME
				,'1'
				,@UserName
				,GETDATE()
			FROM TB_T_CED_PART_INFO
			GROUP BY PART_NO

			--,PART_NAME
			--= Insert into Part Unique =--
			INSERT INTO TB_T_CED_PART_UNIQUE (
				PROCESS_ID
				,PART_NO
				,SUPPLIER_CD
				,SUPPLIER_PLANT_CD
				,UNIQUE_NO
				,SYNC_FLAG
				,PROCESSED_BY
				,PROCESSED_DT
				)
			SELECT DISTINCT @pid
				,PART_NO
				,SUPPLIER_CD
				,SUPPLIER_PLANT
				,KANBAN_NO
				,'1'
				,@UserName
				,GETDATE()
			FROM (
				SELECT ROW_NUMBER() OVER (
						PARTITION BY PART_NO ORDER BY CREATED_DT DESC
						) ROW_NUM
					,PART_NO
					,SUPPLIER_CD
					,SUPPLIER_PLANT
					,KANBAN_NO
					,CREATED_DT
					,START_DT
					,END_DT
				FROM TB_T_CED_PART_INFO
					--FID) Dina 20-Jun-2019 : Modify logic for retrieveonly 1 Part No, Supplier, and Supplier Plant
					--SELECT ROW_NUMBER() OVER (
					--		PARTITION BY PART_NO
					--		,SUPPLIER_CD
					--		,SUPPLIER_PLANT ORDER BY PART_NO
					--			,SUPPLIER_CD
					--			,SUPPLIER_PLANT
					--		) ROW_NUM
					--	,PART_NO
					--	,SUPPLIER_CD
					--	,SUPPLIER_PLANT
					--	,KANBAN_NO
					--FROM TB_T_CED_PART_INFO
					--GROUP BY PART_NO
					--	,SUPPLIER_CD
					--	,SUPPLIER_PLANT
					--	,KANBAN_NO
				) DATA
			WHERE ROW_NUM = 1

			--= Insert into Part Type =--
			INSERT INTO TB_T_CED_PART_TYPE (
				PROCESS_ID
				,PART_NO
				,DOCK_CD
				,QTY_KANBAN
				,SYNC_FLAG
				,PROCESSED_BY
				,PROCESSED_DT
				)
			SELECT DISTINCT @pid
				,PART_NO
				,DOCK_CD
				,SUM(KANBAN_QTY)
				,'1'
				,@UserName
				,GETDATE()
			FROM TB_T_CED_PART_INFO
			GROUP BY PART_NO
				,DOCK_CD;

			--= Remove Duplicate =--
			WITH TempPart (
				PART_NO
				,duplicateCount
				)
			AS (
				SELECT PART_NO
					,ROW_NUMBER() OVER (
						PARTITION BY PART_NO ORDER BY PART_NO
						) AS duplicateCount
				FROM TB_T_CED_PART
				)
			DELETE
			FROM TempPart
			WHERE duplicateCount > 1

			--= Insert into Logistic Partner =--
			INSERT INTO TB_T_CED_LOGISTIC_PARTNER (
				PROCESS_ID
				,LOG_PARTNER_CD
				,LOG_PARTNER_NAME
				,TCYMDFROM
				,ACTIVE_FLAG
				,LOG_PARTNER_ADDRESS
				,POSTAL_CD
				,CITY
				,ATTENTION
				,PHONE_NUMBER
				,FAX_NUMBER
				,NPWP
				,DELETION_FLAG
				,SYNC_FLAG
				,PROCESSED_BY
				,PROCESSED_DT
				)
			SELECT DISTINCT @pid
				,LOG_PARTNER_CD
				,LOG_PARTNER_NAME
				,TCYMDFROM
				,ACTIVE_FLAG
				,LOG_PARTNER_ADDRESS
				,POSTAL_CD
				,CITY
				,ATTENTION
				,PHONE_NUMBER
				,FAX_NUMBER
				,NPWP
				,DELETION_FLAG
				,'1'
				,@UserName
				,GETDATE()
			FROM (
				SELECT ROW_NUMBER() OVER (
						PARTITION BY LOG_PARTNER_CD ORDER BY LOG_PARTNER_ID DESC
						) ROW_NUM
					,LOG_PARTNER_CD
					,LOG_PARTNER_NAME
					,TCYMDFROM
					,ACTIVE_FLAG
					,LOG_PARTNER_ADDRESS
					,POSTAL_CD
					,CITY
					,ATTENTION
					,PHONE_NUMBER
					,FAX_NUMBER
					,NPWP
					,DELETION_FLAG
				FROM TB_M_LOGISTIC_PARTNER
				WHERE DELETION_FLAG <> 'Y'
				) DATA
			WHERE ROW_NUM = 1

			--= Insert into Delivery Station Mapping =--
			INSERT INTO TB_T_CED_DELIVERY_STATION_MAPPING (
				PROCESS_ID
				,DOOR_CD_TLMS
				,DOCK_CD
				,PHYSICAL_DOCK
				,PHYSICAL_STATION
				,USED_FLAG
				,SYNC_FLAG
				,PROCESSED_BY
				,PROCESSED_DT
				)
			SELECT DISTINCT @pid
				,DOOR_CD_TLMS
				,DOCK_CD
				,PHYSICAL_DOCK
				,PHYSICAL_STATION
				,USED_FLAG
				,'0'
				,@UserName
				,GETDATE()
			FROM [dbo].[TB_M_DELIVERY_STATION_MAPPING]
			WHERE 1 = 1
			--FID) Dina 23-Sep-2019 : Additional filter by selected dock cd
			AND PHYSICAL_DOCK IN (
				SELECT items
				FROM dbo.FN_SPLIT(@DOCK_CD, ';')
				)

			--= Insert into Physical Dock Mapping =--
			INSERT INTO TB_T_CED_PHYSICAL_DOCK_MAPPING (
				PROCESS_ID
				,PHYSICAL_LOGPTCD
				,PHYSICAL_PLANTCD
				,PHYSICAL_DOCKCD
				,LOGICAL_LOGPTCD
				,LOGICAL_PLANTCD
				,LOGICAL_DOCKCD
				,PROCESSED_BY
				,PROCESSED_DT
				,SYNC_FLAG
				)
			SELECT DISTINCT @pid
				,PHYSICAL_LOGPTCD
				,PHYSICAL_PLANTCD
				,PHYSICAL_DOCKCD
				,LOGICAL_LOGPTCD
				,LOGICAL_PLANTCD
				,LOGICAL_DOCKCD
				,@UserName
				,GETDATE()
				,'1'
			FROM [dbo].[TB_M_PHYSICAL_DOCK_MAPPING]
			WHERE LOGICAL_DOCKCD IN (
					SELECT items
					FROM dbo.FN_SPLIT(@DOCK_CD, ';')
					)

			--= Insert into DOM =--
			INSERT INTO TB_T_CED_DAILY_ORDER_MANIFEST (
				PROCESS_ID
				,MANIFEST_NO
				,ORDER_NO
				,SUPPLIER_CD
				,SUPPLIER_PLANT_CD
				,ORDER_TYPE
				,ORDER_RELEASE_DT
				,COMPANY_CD
				,RCV_PLANT_CD
				,DOCK_CD
				,TOTAL_ITEM
				,TOTAL_QTY
				,ERROR_QTY
				,ARRIVAL_PLAN_DT
				,ARRIVAL_ACTUAL_DT
				,DELAY_FLAG
				,MANIFEST_RECEIVING_FLAG
				,P_LANE_CD
				,P_LANE_SEQ
				,P_LANE_DT
				,SYNC_FLAG
				,PROCESSED_BY
				,PROCESSED_DT
				)
			SELECT DISTINCT @pid
				,MANIFEST_NO
				,ORDER_NO
				,SUPPLIER_CD
				,SUPPLIER_PLANT
				,ORDER_TYPE
				,ORDER_RELEASE_DT
				,COMPANY_CD
				,RCV_PLANT_CD
				,DOCK_CD
				,TOTAL_ITEM
				,TOTAL_QTY
				,ERROR_QTY
				-- FID.Ridwan 2019-09-04
				--,ARRIVAL_PLAN_DT
				,ISNULL(FST_X_DOCK_ARRIVAL_DT, ARRIVAL_PLAN_DT)
				,ARRIVAL_ACTUAL_DT
				,DELAY_FLAG
				,MANIFEST_RECEIVE_FLAG
				,P_LANE_CD
				,P_LANE_SEQ
				,P_LANE_DT
				,'1'
				,@UserName
				,GETDATE()
			FROM [dbo].[TB_R_DAILY_ORDER_MANIFEST]
			--FID.Dina sementara
			--WHERE MANIFEST_NO IN ('1191288440'
			--	,'1191288717'
			--	,'1191289073'
			--	,'1191290315'
			--	,'1191291271'
			--	,'1191291783'
			--	,'1191293293'
			--	,'1191293518'
			--	,'1191295436'
			--	,'1191291814'
			--	,'1191293788'
			--	,'1191294992'
			--	,'1191288819'
			--	,'1191290003'
			--	,'1191290316'
			--	,'1191290708'
			--	,'1191291471'
			--	,'1191294400'
			--	,'1191297701'
			--	,'1191293810'
			--	,'1191296031'
			--	,'1191290110'
			--	,'1191290220'
			--	,'1191293640'
			--	,'1191294651'
			--	,'1191291932'
			--	,'1191292295'
			--	,'1191288604'
			--	,'1191292352'
			--	,'1191294776'
			--	,'1191293180'
			--	,'1191295038'
			--	,'1191295233'
			--	)
			WHERE ORDER_RELEASE_DT BETWEEN CONVERT(DATE, GETDATE() - CAST(@ORDER_RELEASE_FROM AS INT))
					AND CONVERT(DATE, GETDATE() + CAST(@ORDER_RELEASE_TO AS INT))
						-- Remark by FID.Ridwan : 2019-08-28
						--AND DOCK_CD IN (
						--	SELECT items
						--	FROM dbo.FN_SPLIT(@DOCK_CD, ';')
						--	)
						--AND COMPANY_CD IN (
						--	SELECT items
						--	FROM dbo.FN_SPLIT(@COMPANY_CD, ';')
						--	)
						--AND RCV_PLANT_CD IN (
						--	SELECT items
						--	FROM dbo.FN_SPLIT(@RCV_PLANT_CD, ';')
						--	)
				AND MANIFEST_RECEIVE_FLAG = '0'
				--FID.Ridwan 2019-10-18 : temporary
				--AND LEFT(ORDER_NO, 8) >= '20191028'

			IF @EO_Flag = '1'
			BEGIN
				DELETE
				FROM TB_T_CED_DAILY_ORDER_MANIFEST

				INSERT INTO TB_T_CED_DAILY_ORDER_MANIFEST (
					PROCESS_ID
					,MANIFEST_NO
					,ORDER_NO
					,SUPPLIER_CD
					,SUPPLIER_PLANT_CD
					,ORDER_TYPE
					,ORDER_RELEASE_DT
					,COMPANY_CD
					,RCV_PLANT_CD
					,DOCK_CD
					,TOTAL_ITEM
					,TOTAL_QTY
					,ERROR_QTY
					,ARRIVAL_PLAN_DT
					,ARRIVAL_ACTUAL_DT
					,DELAY_FLAG
					,MANIFEST_RECEIVING_FLAG
					,P_LANE_CD
					,P_LANE_SEQ
					,P_LANE_DT
					,SYNC_FLAG
					,PROCESSED_BY
					,PROCESSED_DT
					)
				SELECT DISTINCT @pid
					,MANIFEST_NO
					,ORDER_NO
					,SUPPLIER_CD
					,SUPPLIER_PLANT
					,ORDER_TYPE
					,ORDER_RELEASE_DT
					,COMPANY_CD
					,RCV_PLANT_CD
					,DOCK_CD
					,TOTAL_ITEM
					,TOTAL_QTY
					,ERROR_QTY
					-- FID.Ridwan 2019-09-04
					--,ARRIVAL_PLAN_DT
					,ISNULL(FST_X_DOCK_ARRIVAL_DT, ARRIVAL_PLAN_DT)
					,ARRIVAL_ACTUAL_DT
					,DELAY_FLAG
					,MANIFEST_RECEIVE_FLAG
					,P_LANE_CD
					,P_LANE_SEQ
					,P_LANE_DT
					,'1'
					,@UserName
					,GETDATE()
				FROM [dbo].[TB_R_DAILY_ORDER_MANIFEST]
				WHERE LEFT(MANIFEST_NO, 1) = 'E'
						--FID.Dina 08-Oct-2019
						--AND ORDER_RELEASE_DT BETWEEN CONVERT(DATE, GETDATE() - CAST(@ORDER_RELEASE_FROM AS INT))
						--AND CONVERT(DATE, GETDATE() + CAST(@ORDER_RELEASE_TO AS INT))
							-- Remark by FID.Ridwan : 2019-08-28
							--AND DOCK_CD IN (
							--	SELECT items
							--	FROM dbo.FN_SPLIT(@DOCK_CD, ';')
							--	)
							--AND COMPANY_CD IN (
							--	SELECT items
							--	FROM dbo.FN_SPLIT(@COMPANY_CD, ';')
							--	)
							--AND RCV_PLANT_CD IN (
							--	SELECT items
							--	FROM dbo.FN_SPLIT(@RCV_PLANT_CD, ';')
							--	)
					AND MANIFEST_RECEIVE_FLAG = '0'
					--FID.Ridwan 2019-10-18 : temporary
					--AND LEFT(ORDER_NO, 8) >= '20191028'
			END

			--= FID.Ridwan 2019-09-04 : update departure plan dt from staging dom (for handle performance issue) =--
			--= Update Staging DOM =--
			UPDATE B
			SET B.DEPARTURE_PLAN_DT = D.DEPARTURE_PLAN_DT
			FROM tb_r_delivery_ctl_h H
			INNER JOIN TB_R_DELIVERY_CTL_D D ON H.DELIVERY_NO = D.DELIVERY_NO
			INNER JOIN TB_R_DCL_TLMS_ORDER_ASSIGNMENT A ON CAST(H.PICKUP_DT AS DATE) = CAST(A.RTEDATE AS DATE)
				AND H.ROUTE = A.RTEGRPCD
				AND H.RATE = RIGHT('00' + A.RUNSEQ, 2)
			INNER JOIN TB_T_CED_DAILY_ORDER_MANIFEST B ON LEFT(A.ORDDATE, 8) + RIGHT('00' + CAST(A.ORDSEQ AS VARCHAR(2)), 2) = B.ORDER_NO
				AND A.RCVCOMPDOCKCD = B.DOCK_CD
				AND A.SUPPCD = B.SUPPLIER_CD
				AND A.SUPPPLANTCD = B.SUPPLIER_PLANT_CD
				AND D.ARRIVAL_PLAN_DT = B.ARRIVAL_PLAN_DT

			--= Insert into DOP =--
			INSERT INTO TB_T_CED_DAILY_ORDER_PART (
				PROCESS_ID
				,MANIFEST_NO
				,ITEM_NO
				,SUPPLIER_PLANT
				,RCV_PLANT_CD
				,DOCK_CD
				,PART_BARCODE
				,PART_NO
				,KANBAN_PRINT_ADDRESS
				,KANBAN_NO
				,QTY_PER_CONTAINER
				,ORDER_QTY
				,ORDER_PLAN_QTY_LOT
				,RECEIVED_STATUS
				,PROCESS_TYPE
				,CASE_NO
				,MOD_DST_CD
				,BOX_NO
				,PLN_PCK_DT
				,CONT_SNO
				,LOT_MOD_NO
				,SYNC_FLAG
				,PROCESSED_BY
				,PROCESSED_DT
				)
			SELECT DISTINCT @pid
				,A.MANIFEST_NO
				,A.ITEM_NO
				,A.SUPPLIER_PLANT
				,A.RCV_PLANT_CD
				,A.DOCK_CD
				,A.PART_BARCODE
				,A.PART_NO
				,A.KANBAN_PRINT_ADDRESS
				,A.KANBAN_NO
				,A.QTY_PER_CONTAINER
				,A.ORDER_QTY
				,A.ORDER_PLAN_QTY_LOT
				,A.RECEIVED_STATUS
				,A.PROCESS_TYPE
				,A.CASE_NO
				,A.MOD_DST_CD
				,A.BOX_NO
				,A.PLN_PCK_DT
				,A.CONT_SNO
				,A.LOT_MOD_NO
				,'1'
				,@UserName
				,GETDATE()
			FROM [dbo].[TB_R_DAILY_ORDER_PART] A
			JOIN TB_T_CED_DAILY_ORDER_MANIFEST B ON A.MANIFEST_NO = B.MANIFEST_NO

			--= Insert into Delivery Ctl Manifest =--
			INSERT INTO TB_T_CED_DELIVERY_CTL_MANIFEST (
				PROCESS_ID
				,DELIVERY_NO
				,DOCK_CD
				,STATION
				,MANIFEST_NO
				,MANIFEST_TYPE
				,SYNC_FLAG
				,PROCESSED_BY
				,PROCESSED_DT
				)
			SELECT DISTINCT @pid
				,A.DELIVERY_NO
				,A.DOCK_CD
				,A.STATION
				,A.MANIFEST_NO
				,A.MANIFEST_TYPE
				,'1'
				,@UserName
				,GETDATE()
			FROM [dbo].[TB_R_DELIVERY_CTL_MANIFEST] A
			JOIN TB_T_CED_DAILY_ORDER_MANIFEST B ON A.MANIFEST_NO = B.MANIFEST_NO

			--= Insert into Dcl Tlms Order Assignment =--
			INSERT INTO TB_T_CED_DCL_TLMS_ORDER_ASSIGNMENT (
				PROCESS_ID
				,CONCTOCRTE
				,CONCTOCRTETRP
				,CONCTODRTEDATE
				,RTEGRPCD
				,RUNSEQ
				,RTEDATE
				,SUPPCD
				,SUPPPLANTCD
				,SUPPDOCKCD
				,NUMPALLETE
				,ORDDATE
				,ORDSEQ
				,RCVCOMPDOCKCD
				,DHNDSTRTIME2
				,DHNDENDTIME2
				,SUPPNAME
				,PARTEMPKBTYPECD
				,UNLOADSTRDATE
				,UNLOADSTRTIME
				,UNLOADENDDATE
				,UNLOADENDTIME
				,PLANE
				,SYNC_FLAG
				,PROCESSED_BY
				,PROCESSED_DT
				)
			SELECT DISTINCT @pid
				,A.CONCTOCRTE
				,A.CONCTOCRTETRP
				,A.CONCTODRTEDATE
				,A.RTEGRPCD
				,A.RUNSEQ
				,A.RTEDATE
				,A.SUPPCD
				,A.SUPPPLANTCD
				,A.SUPPDOCKCD
				,A.NUMPALLETE
				,A.ORDDATE
				,A.ORDSEQ
				,A.RCVCOMPDOCKCD
				,A.DHNDSTRTIME2
				,A.DHNDENDTIME2
				,A.SUPPNAME
				,A.PARTEMPKBTYPECD
				,A.UNLOADSTRDATE
				,A.UNLOADSTRTIME
				,A.UNLOADENDDATE
				,A.UNLOADENDTIME
				,A.PLANE
				,'1'
				,@UserName
				,GETDATE()
			FROM [dbo].[TB_R_DCL_TLMS_ORDER_ASSIGNMENT] A
			JOIN TB_T_CED_DAILY_ORDER_MANIFEST B ON LEFT(A.ORDDATE, 8) + RIGHT('00' + CAST(A.ORDSEQ AS VARCHAR(2)), 2) = B.ORDER_NO
				AND A.RCVCOMPDOCKCD = B.DOCK_CD
				AND A.SUPPCD = B.SUPPLIER_CD
				AND A.SUPPPLANTCD = B.SUPPLIER_PLANT_CD
			WHERE 1 = 1
				AND A.RTEGRPCD NOT IN (
					SELECT items
					FROM dbo.FN_SPLIT(@ROUTE_PLANT, ';')
					) --FID) Dina 18-Jun-2019

			--= Insert into Dcl Tlms Driver Data =--
			INSERT INTO TB_T_CED_DCL_TLMS_DRIVER_DATA (
				PROCESS_ID
				,APPLTERMFROM
				,APPLTERMTO
				,RTEGRPCD
				,RTEDATE
				,RUNSEQ
				,LOGPTCD
				,DOCKCD
				,PLANTCD
				,INBOUTBFLAG
				,DRIVERACCSEQ
				,LOGPARTNERCD
				,ARRVDATETIME
				,DPTDATETIME
				,TRAVELDISTKM
				,DOORCD
				,SYNC_FLAG
				,PROCESSED_BY
				,PROCESSED_DT
				)
			SELECT DISTINCT @pid
				,A.APPLTERMFROM
				,A.APPLTERMTO
				,A.RTEGRPCD
				,A.RTEDATE
				,A.RUNSEQ
				,A.LOGPTCD
				,A.DOCKCD
				,A.PLANTCD
				,A.INBOUTBFLAG
				,A.DRIVERACCSEQ
				,A.LOGPARTNERCD
				,A.ARRVDATETIME
				,A.DPTDATETIME
				,A.TRAVELDISTKM
				,A.DOORCD
				,'1'
				,@UserName
				,GETDATE()
			FROM [dbo].[TB_R_DCL_TLMS_DRIVER_DATA] A
			JOIN TB_T_CED_DCL_TLMS_ORDER_ASSIGNMENT B ON A.RTEGRPCD = B.RTEGRPCD
				AND A.RUNSEQ = B.RUNSEQ
				AND A.RTEDATE = B.RTEDATE

			--AND A.DOCKCD = B.RCVCOMPDOCKCD FID)Dina 02-Sep-2019
			--= Insert into Delivery Ctl H =--
			INSERT INTO TB_T_CED_DELIVERY_CTL_H (
				PROCESS_ID
				,DELIVERY_NO
				,DELIVERY_TYPE
				,REVISE_NO
				,PICKUP_DT
				,ROUTE
				,RATE
				,LP_CD
				,CONFIRM_STS
				,DELIVERY_STS
				,CANCEL_FLAG
				,APPROVE_BY
				,APPROVE_DT
				,REJECT_BY
				,REJECT_DT
				,NOTIFY_STS
				,SYNC_FLAG
				,PROCESSED_BY
				,PROCESSED_DT
				,PUSH_TO_WEB_FLAG
				)
			SELECT DISTINCT @pid
				,A.DELIVERY_NO
				,A.DELIVERY_TYPE
				,A.REVISE_NO
				,A.PICKUP_DT
				,A.ROUTE
				,A.RATE
				,A.LP_CD
				,A.CONFIRM_STS
				,A.DELIVERY_STS
				,A.CANCEL_FLAG
				,A.APPROVE_BY
				,A.APPROVE_DT
				,A.REJECT_BY
				,A.REJECT_DT
				,A.NOTIFY_STS
				,'1'
				,@UserName
				,GETDATE()
				,PUSH_TO_WEB_FLAG
			FROM [dbo].[TB_R_DELIVERY_CTL_H] A
			JOIN TB_T_CED_DCL_TLMS_DRIVER_DATA B ON A.PICKUP_DT = B.RTEDATE
				AND A.ROUTE = B.RTEGRPCD
				AND A.RATE = RIGHT('00' + B.RUNSEQ, 2)
			--FID.Dina 01-Oct-2019 : Remark filter based on Delivery Status
			--WHERE A.DELIVERY_STS IN (
			--		'initial'
			--		,'downloaded'
			--		)

			--= Insert into Delivery Ctl D =--
			INSERT INTO TB_T_CED_DELIVERY_CTL_D (
				PROCESS_ID
				,DELIVERY_NO
				,DOCK_CD
				,STATION
				,ARRIVAL_GATE_DT
				,ARRIVAL_PLAN_DT
				,DEPARTURE_PLAN_DT
				,ARRIVAL_STATUS
				,ARRIVAL_GAP
				,ARRIVAL_ACTUAL_DT
				,DEPARTURE_ACTUAL_DT
				,DEPARTURE_STATUS
				,DEPARTURE_GAP
				,REMAINING
				,DOOR_CD
				,ABANDON_FLAG
				,CONFIRM_FLAG
				,SYNC_FLAG
				,PROCESSED_BY
				,PROCESSED_DT
				)
			SELECT DISTINCT @pid
				,A.DELIVERY_NO
				,A.DOCK_CD
				,A.STATION
				,A.ARRIVAL_GATE_DT
				,A.ARRIVAL_PLAN_DT
				,A.DEPARTURE_PLAN_DT
				,A.ARRIVAL_STATUS
				,A.ARRIVAL_GAP
				,A.ARRIVAL_ACTUAL_DT
				,A.DEPARTURE_ACTUAL_DT
				,A.DEPARTURE_STATUS
				,A.DEPARTURE_GAP
				,A.REMAINING
				,A.DOORCD
				,A.ABANDON_FLAG
				,A.CONFIRM_FLAG
				,'1'
				,@UserName
				,GETDATE()
			FROM [dbo].[TB_R_DELIVERY_CTL_D] A
			JOIN TB_T_CED_DELIVERY_CTL_H B ON A.DELIVERY_NO = B.DELIVERY_NO --AND A.DOCK_CD=B.DOCK_CD

			-- Add by FID.Ridwan : 2019-08-28
			--CREATE TABLE #LIST_MANIFEST 
			--(
			--	MANIFEST_NO VARCHAR(MAX)
			--)
			--INSERT INTO #LIST_MANIFEST
			--SELECT DISTINCT B.MANIFEST_NO
			--FROM TB_T_CED_DAILY_ORDER_MANIFEST B
			--WHERE 1 = 1
			--	AND B.DOCK_CD NOT IN (
			--		SELECT items
			--		FROM dbo.FN_SPLIT(@DOCK_CD, ';')
			--		)
			--INSERT INTO #LIST_MANIFEST
			--SELECT DISTINCT B.MANIFEST_NO
			--FROM TB_T_CED_DAILY_ORDER_MANIFEST B
			--WHERE 1 = 1
			--	AND B.COMPANY_CD NOT IN (
			--		SELECT items
			--		FROM dbo.FN_SPLIT(@COMPANY_CD, ';')
			--		)
			--	AND B.MANIFEST_NO NOT IN (SELECT DISTINCT MANIFEST_NO FROM #LIST_MANIFEST)
			--INSERT INTO #LIST_MANIFEST
			--SELECT DISTINCT B.MANIFEST_NO
			--FROM TB_T_CED_DAILY_ORDER_MANIFEST B
			--WHERE 1 = 1
			--	AND B.RCV_PLANT_CD NOT IN (
			--		SELECT items
			--		FROM dbo.FN_SPLIT(@RCV_PLANT_CD, ';')
			--		)
			--	AND B.MANIFEST_NO NOT IN (SELECT DISTINCT MANIFEST_NO FROM #LIST_MANIFEST)
			--DELETE A
			--FROM [dbo].[TB_T_CED_DAILY_ORDER_PART] A
			--WHERE A.MANIFEST_NO IN (SELECT DISTINCT MANIFEST_NO FROM #LIST_MANIFEST)
			--DELETE A
			--FROM TB_T_CED_DAILY_ORDER_MANIFEST A
			--WHERE A.MANIFEST_NO IN (SELECT DISTINCT MANIFEST_NO FROM #LIST_MANIFEST)
			-- End Add by FID.Ridwan : 2019-08-28
			SET @log = 'Insert into Temp Table for sending data to TVEST is ended with success.';

			INSERT INTO @TB_T_LOG_D
			SELECT @pid
				,NULL
				,'MCEDSTD008I'
				,'INF'
				,@log
				,'End log with success'
				,@Username
				,GETDATE()

			SELECT TOP 1 @R_SEQ_NO = SEQUENCE_NUMBER
			FROM TB_R_LOG_D
			WHERE PROCESS_ID = @pid
			ORDER BY SEQUENCE_NUMBER DESC

			INSERT INTO TB_R_LOG_D (
				PROCESS_ID
				,SEQUENCE_NUMBER
				,MESSAGE_ID
				,MESSAGE_TYPE
				,[MESSAGE]
				,LOCATION
				,CREATED_BY
				,CREATED_DATE
				)
			SELECT PROCESS_ID
				,@R_SEQ_NO + ROW_NUMBER() OVER (
					ORDER BY PROCESS_ID
					)
				,MESSAGE_ID
				,MESSAGE_TYPE
				,[MESSAGE]
				,LOCATION
				,CREATED_BY
				,CREATED_DATE
			FROM @TB_T_LOG_D

			UPDATE TB_R_LOG_H
			SET PROCESS_STATUS = 1
			WHERE PROCESS_ID = @pid

			--DROP TABLE #LIST_MANIFEST
			SELECT 'N' AS isResult
		END
	END TRY

	BEGIN CATCH
		SET @log = ERROR_MESSAGE();

		INSERT INTO @TB_T_LOG_D
		SELECT @pid
			,NULL
			,'MCED0312001E'
			,'ERR'
			,@log
			,'Daily order part data for Kanban 2 not found'
			,@Username
			,GETDATE()

		SET @log = 'Create Kanban 2 Batch is ended with error.';

		INSERT INTO @TB_T_LOG_D
		SELECT @pid
			,NULL
			,'MCEDSTD009I'
			,'INF'
			,@log
			,'End log with error'
			,@Username
			,GETDATE()

		SELECT TOP 1 @R_SEQ_NO = SEQUENCE_NUMBER
		FROM TB_R_LOG_D
		WHERE PROCESS_ID = @pid
		ORDER BY SEQUENCE_NUMBER DESC

		INSERT INTO TB_R_LOG_D (
			PROCESS_ID
			,SEQUENCE_NUMBER
			,MESSAGE_ID
			,MESSAGE_TYPE
			,[MESSAGE]
			,LOCATION
			,CREATED_BY
			,CREATED_DATE
			)
		SELECT PROCESS_ID
			,@R_SEQ_NO + ROW_NUMBER() OVER (
				ORDER BY PROCESS_ID
				)
			,MESSAGE_ID
			,MESSAGE_TYPE
			,[MESSAGE]
			,LOCATION
			,CREATED_BY
			,CREATED_DATE
		FROM @TB_T_LOG_D

		UPDATE TB_R_LOG_H
		SET PROCESS_STATUS = 6
		WHERE PROCESS_ID = @pid

		SELECT 'Y' AS isResult
	END CATCH
END

